<?php
/**
 * Created by PhpStorm.
 * User: HLXLIYIFEI
 * Date: 2015/3/14
 * Time: 10:15
 */

/**
 * ½
 * Class ThirdLogin
 */
class ThirdLogin extends BaseApi
{
    private $_db;
    private $_tableName;

    public function __construct()
    {
        global $PW, $db;
        $this->_db = & $db;
        $this->_tableName = $PW . 'third_bind';
    }

    /**
     * ȡû󶨵ĵϢ
     * @param $uid
     * @param $weibotype
     * @return bool
     */
    public function fetchPlatform( $uid, $weibotype )
    {
        $platform = $this->_db->get_one( "SELECT * FROM " . $this->_tableName . " WHERE uid = " . S::sqlEscape($uid) . " AND weibotype = " . strtoupper( S::sqlEscape($weibotype) ) . " LIMIT 1" );

        return $platform;
    }

    /**
     * ȡû
     * @param $openid
     * @param $weibotype
     * @return int
     */
    public function fetchUser( $openid, $weibotype )
    {
        $user = $this->_getBindInfo( $openid, $weibotype );

        if( !empty($user) )
        {
            return $user['uid'];
        }

        return 0;
    }

    /**
     * 󶨵˻
     * @param $userId
     * @param $openid
     * @param $weibotype
     * @param $nickname
     */
    public function bindUser( $userId, $openid, $weibotype, $nickname )
    {
        $uid = $this->_db->get_value( "select `uid` from " . $this->_tableName . " where `uid` = ". S::sqlEscape($userId) ." and `openid` = " . S::sqlEscape($openid) . " and `weibotype` = " . strtolower( S::sqlEscape($weibotype) ) );

        if( $uid > 0 )
        {

        }
        else
        {
            $pwSql = array(
                'uid' => $userId,
                'openid' => $openid,
                'nickname' => $nickname,
                'weibotype' => strtolower( $weibotype ),
                'info' => ''
            );
            $this->_db->update("INSERT INTO " . $this->_tableName . " SET " . S::sqlSingle( $pwSql ) );
        }
    }

    //ȡϢ
    private function _getBindInfo( $openid, $weibotype )
    {
        $bindInfo = $this->_db->get_one( "select uid, weibotype from " . $this->_tableName . " where `openid` = " . S::sqlEscape($openid) . " and `weibotype` = ". strtolower( S::sqlEscape($weibotype) ) ." limit 1" );

        if( empty($bindInfo) )
        {
            return null;
        }

        return $bindInfo;
    }

    // ȡ΢ŰûϢ
    private function _getWechatInfo( $unionId, $weibotype )
    {
        $bindInfo = $this->_db->get_one( "select uid, weibotype from " . $this->_tableName . " where `unionid` = " . S::sqlEscape($unionId) . " and `weibotype` = ". strtolower( S::sqlEscape($weibotype) ) ." limit 1" );

        if( empty($bindInfo) )
        {
            return null;
        }

        return $bindInfo;
    }

    // ΢û
    public function bindWechatUser( $userId, $openid, $unionId, $weibotype, $nickname )
    {
        $uid = $this->_db->get_value( "select `uid` from " . $this->_tableName . " where `uid` = ". S::sqlEscape($userId) . " and `weibotype` = " . strtolower( S::sqlEscape($weibotype) ) );

        $pwSql = array(
            'uid' => $userId,
            'openid' => $openid,
            'unionid' => $unionId,
            'nickname' => $nickname,
            'weibotype' => strtolower( $weibotype ),
            'info' => ''
        );

        if( $uid > 0 ) {
            if(!$pwSql['nickname']) unset($pwSql['nickname']);
            if(!$pwSql['info']) unset($pwSql['info']);
            $this->_db->update("UPDATE " . $this->_tableName . " SET " . S::sqlSingle( $pwSql ) . " WHERE uid=" . S::sqlEscape($uid) );

        } else {
            $this->_db->update("INSERT INTO " . $this->_tableName . " SET " . S::sqlSingle( $pwSql ) );
        }

        return true;
    }

    public function fetchWechatUser( $unionId, $weibotype )
    {
        $user = $this->_getWechatInfo( $unionId, $weibotype );

        if( !empty($user) )
        {
            return $user['uid'];
        }

        return 0;
    }

    // ûuidȡ
    public function getUserinfoByUid( $uid, $weibotype ) {
        $bindInfo = $this->_db->get_one( "select * from " . $this->_tableName . " where `uid` = " . S::sqlEscape($uid) . " and `weibotype` = ". strtolower( S::sqlEscape($weibotype) ) ." limit 1" );
        $result = !empty($bindInfo) ? $bindInfo : array();

        return $result;
    }

    // ¼ͬûunionidϢ
    public function updateUserUnionid( $uid, $weibotype, $unionid ) {
        $this->_db->update( "UPDATE " . $this->_tableName . " SET unionid=" . S::sqlEscape($unionid) . " WHERE uid=" . S::sqlEscape($uid) . " AND weibotype=" . strtolower( S::sqlEscape($weibotype) ) );
    }

    // ûƽ̨
    public function unbindThirdPlatform( $uid, $weibotype ) {
        $this->_db->update( "DELETE FROM " . $this->_tableName . " WHERE uid=" . S::sqlEscape($uid) . 'AND weibotype=' . S::sqlEscape($weibotype) );
    }
}